/**********************************************************************
						       BIF.H
				Please set tabstop=4 if edit using vi
**********************************************************************/

struct ASSOCIATED_STMT_S {
            PTR_BFND    next_stat;   /* to a SgStatement after
                                       end_type_stmt */
            PTR_CMNT    cmnt_ptr;   /* to the comment */

            PTR_SYMB     symbol;     /* to a SgTypeSymel of type_name */

            PTR_LLND    pointer_object; /* changed. in sage++ it is attributs
                                      for access_spec  */
            PTR_LLND    target_pointer;
            PTR_LLND    result;

            PTR_LABEL   null_1;

            PTR_BLOB    null_2;   /* to statements betwean derived_type_stmt
                                      and end_type_stmt */
            PTR_BLOB    null_3;

            PTR_DEP     dep_from;
            PTR_DEP     dep_to;

            PTR_SETS    sets;
        };


struct STRUCT_DECL_S { /* for SgStructureDeclStmt */
			PTR_BFND    type_end;   /* to a SgStatement after
									   end_type_stmt */
			PTR_CMNT    cmnt_ptr;   /* to the comment */
			
			PTR_SYMB     symbol;     /* to a SgTypeSymel of type_name */
			
			PTR_LLND    attribute; /* changed. in sage++ it is attributs
									  for access_spec  */
			PTR_LLND    null_1;
			PTR_LLND    null_2;
			
			PTR_LABEL   null_3;
			
			PTR_BLOB    control;   /* to statements betwean derived_type_stmt
									  and end_type_stmt */
			PTR_BLOB    null_4;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		};

struct MISCELL_STMT_S { /* for SgMiscellStmt */
			PTR_BFND    next_stat;   
			PTR_CMNT    cmnt_ptr;
			
			PTR_SYMB     null_1;
			
			PTR_LLND    null_2;
			PTR_LLND    null_3;
			PTR_LLND    null_4;
			
			PTR_LABEL   null_5;
			
			PTR_BLOB    null_6;
			PTR_BLOB    null_7;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		};

struct VAR_DECL_STMT_S { /* for SgVarDeclStmt */
			PTR_BFND    next_stat;  /* to next statement */
			PTR_CMNT    cmnt_ptr;   /* to comments */
			
			PTR_SYMB     null_1;
																											   
			PTR_LLND    entities; /* to a SgExprListExp of entity_decl_list */
			PTR_LLND    type;       /* to a SgTypeExp.changed */           
			PTR_LLND    attributes; /* to a SgExprListExp of attribute_list */
			
			PTR_LABEL   null_2;

			PTR_BLOB    null_3;
			PTR_BLOB    null_4;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		};

struct INTENT_STMT_S { /* for SgIntentStmt */
			PTR_BFND    last_stat;  /* for last statement */
			PTR_CMNT    cmnt_ptr;   /* for comments */
			
			PTR_SYMB     null_1;
			
			PTR_LLND    list;       /* to a SgExprListExp for objects */
			PTR_LLND    attr_expr;  /* to a SgAtributExp */
			PTR_LLND    null_2;
			
			PTR_LABEL   null_3;
			
			PTR_BLOB    null_4;
			PTR_BLOB    null_5;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		}    ;

struct VAR_LIST_DECL_STMT_S { /* for SgVarListDeclStmt */
			PTR_BFND    next_stat;
			PTR_CMNT    cmnt_ptr;
			
			PTR_SYMB     null_1;
			
			PTR_LLND    list;       /* to a SgExprListExp for objects */
/*			PTR_LLND    null_2;*/
			PTR_LLND    access_expr; /* added by Feng Xiaobing, for access statement in a module */
			PTR_LLND    null_3;
			
			PTR_LABEL   null_4;
			
			PTR_BLOB    null_5;
			PTR_BLOB    null_6;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		};

struct IMPL_DECL_STMT_S { /* for SgImplicitStmt */
			PTR_BFND    next_stat;      /* for next statement */
			PTR_CMNT    cmnt_ptr;       /* for comments */
			
			PTR_SYMB     null_1;
																											   
			PTR_LLND    list;           /* to a SgExprListExp of RANGE_VAL */
			PTR_LLND    null_2;
			PTR_LLND    null_3;
			
			PTR_LABEL   null_4;

			PTR_BLOB    null_5;
			PTR_BLOB    null_6;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		};

struct NEST_VAR_LIST_DECL_S { /* for SgNestVarListDeclStmt */
			PTR_BFND   next_stat;   /* for next statment*/
			PTR_CMNT   cmnt_ptr;    /* for comments*/ 
			
			PTR_SYMB    null_1;
			
			PTR_LLND   list;        /*to a SgExprListExp of SgObjectListExp */
			PTR_LLND   null_2; 
			PTR_LLND   null_3;
			
			PTR_LABEL  null_4;
			
			PTR_BLOB   null_5;
			PTR_BLOB   null_6;

			PTR_DEP    dep_from;
			PTR_DEP    dep_to;

			PTR_SETS   sets;
		};

struct HEAP_STMT_S { /* for SgHeapStmt */
			PTR_BFND    next_stat;  /* for next statement */
			PTR_CMNT    cmnt_ptr;   /* for comments */
			
			PTR_SYMB     null_1;
																											   
			PTR_LLND    list;       /* objects list */
			PTR_LLND    stat;       /* stat_variable */
			PTR_LLND    null_2;
			
			PTR_LABEL   null_3;
			
			PTR_BLOB    null_4;
			PTR_BLOB    null_5;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
	   };

struct NULLIFY_STMT_S { /* for SgNullifyStmt */
			PTR_BFND    next_stat;
			PTR_CMNT    cmnt_ptr;
			
			PTR_SYMB     null_1;
																											   
			PTR_LLND    list;       /* objects list */
			PTR_LLND    null_2;
			PTR_LLND    null_3;
			
			PTR_LABEL   null_4;
			
			PTR_BLOB    null_5;
			PTR_BLOB    null_6;

			PTR_DEP     dep_from;
			PTR_DEP     dep_to;

			PTR_SETS    sets;
		};

struct DO_STMT_S { /* for SgForStmt */
		  PTR_BFND  do_end;      /* next statement after do construct */
		  PTR_CMNT  cmnt_ptr;    /* comments    */

		  PTR_SYMB   control_var; /* do variable */

		  PTR_LLND  range;       /* point to a LLND object contain
									start and end expressions       */  
		  PTR_LLND  increment;   /* step */
		  PTR_LLND  construct_name;/* point to LLND object which store
									  do construct_name at SYMB field */

		  PTR_LABEL do_label;

		  PTR_BLOB  control;
		  PTR_BLOB  null_1;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct DO_WHILE_STMT_S { /* for SgWhileStmt */
		  PTR_BFND  do_end;    /* next statement after do while statement  */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  conditional; /* while logical expression */  
		  PTR_LLND  null_2;
		  PTR_LLND  construct_name;/* point to LLND object which store
									  do construct_name at SYMB field */

		  
		  PTR_LABEL do_label;

		  PTR_BLOB  control;
		  PTR_BLOB  null_4;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct IF_STMT_S { /* for SgLogIfStmt */
		  PTR_BFND  true_branch ;/* next statement after logic if statement */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct  IF_THEN_ELSE_S { /* for SgIfStmt */
		  PTR_BFND  true_branch;/* next statement after if then else statement */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   construct_name;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  control_false;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
	}       ;

struct IF_ELSE_IF_STMT_S { /* for SgIfElseIfStmt */
		  PTR_BFND  true_branch;/* next statement after if construct */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   construct_name;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  control_false;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct  ARITH_IF_STMT_S {   /* for SgArithIfStmt */
		  PTR_BFND  true_branch;/* next statement after arithmetic if statement */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  condition;
		  PTR_LLND  label_list;/* point to a label_list expression */
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  null_4;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		 };

struct WHERE_STMT_S { /* for SgWhereStmt */
		  PTR_BFND  true_branch ;/* next statement after where statement */

		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  condition; /* mask expr */
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;/* point to an assignment statement */
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct WHERE_BLOCK_STMT_S { /* for SgWhereBlockStmt */
		  PTR_BFND  true_branch;/* next statement after where construct */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  condition; /* mask expr */
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  control_false;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct CASE_STMT_S { /* for SgSwitchStmt */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   construct_name;/* case construct name */ 

		  PTR_LLND  selector;     /* case selector  */
		  PTR_LLND  null_1;
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  case_option_stmt_list;/* used for  case 
										option statment list */
		  PTR_BLOB  null_4;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct CASE_OPTION_STMT_S { /* for SgCaseOptionStmt */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   construct_name;/* case construct name */ 

		  PTR_LLND  case_option_expr_list; /* used for case option 
												expression list  */
		  PTR_LLND  null_1;
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  control;
		  PTR_BLOB  null_4;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
};

struct   CONTINUE_STMT_S  {   /* for SgContinueStmt */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  null_4;

		  PTR_LABEL null_5;

		  PTR_BLOB  null_6;
		  PTR_BLOB  null_7;

		  PTR_DEP   null_8;
		  PTR_DEP   null_9;

		  PTR_SETS  sets;
		};

struct GOTO_STMT_S { /* for SgGotoStmt */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   null_1;

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  target_label;  /* label */

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   null_7;
		  PTR_DEP   null_8;

		  PTR_SETS  sets;
		};

struct  ASSIGN_STMT_S { /* for SgAssignStmt */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   null_1;

		  PTR_LLND  l_value;    /* variable or pointer_object */
		  PTR_LLND  r_value;    /* exor or target */
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  null_4;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct ASSLAB_STAT_S { /* for SgAssignLabelStmt */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   null_1;

		  PTR_LLND  l_value;   /* label */
		  PTR_LLND  r_value;   /* scalar_int_variable */
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  null_4;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		};

struct  ASSGOTO_NODE_S { /* for SgAssignGotoStmt */
		  PTR_BFND  next_stat;       
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   goto_variable;

		  PTR_LLND  label_list;/* point to a label_list expression list */
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;
		  
		  PTR_SETS  sets;
		};

struct  COMPGOTO_NODE_S { /* for SgComputedGotoStmt */
		  PTR_BFND  next_stat;       
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   null_2;

		  PTR_LLND  label_list;/* point to a label_list expression list */
		  PTR_LLND  goto_expr;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;
		  
		  PTR_SETS  sets;
		};

struct STOP_STAT_S { /* for SgStopOrPauseStmt */
		  PTR_BFND  next_stat;       
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   null_1;

		  PTR_LLND  stop_code;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;
		  
		  PTR_SETS  sets;
		};

struct CYCLE_STMT_S { /* for SgCycleStmt */
		  PTR_BFND  next_stat;       
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   construct_name;

		  PTR_LLND  null_1;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;
		  
		  PTR_SETS  sets;
		};

struct EXIT_STMT_S { /* for SgExitStmt */
		  PTR_BFND  next_stat;       
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB   construct_name;

		  PTR_LLND  null_1;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;
		  
		  PTR_SETS  sets;
		};

struct CONTROL_END_STMT_S { /* for SgControlEndStmt  */
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB   control_name;  

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  null_4;

		  PTR_LABEL null_5;

		  PTR_BLOB  null_6;
		  PTR_BLOB  null_7;

		  PTR_DEP   null_8;
		  PTR_DEP   null_9;

		  PTR_SETS  sets;
		};

struct FUNCTION_STMT_S { /* for SgFuncHedrStmt */
	PTR_BFND next_func;
	PTR_CMNT cmnt_ptr; /*attach to coments*/

	PTR_SYMB  func_symb; /*point to function symbol*/

	PTR_LLND ftype; /*returned result */
	PTR_LLND prefix;  /* modified by Lxy (12/19/1995) */
	PTR_LLND null_2;

	PTR_LABEL null_3;

	PTR_BLOB  control;  /*point to the body of function*/
	PTR_BLOB  format_group; /*internal subprogram part */

	PTR_DEP   null_4;
	PTR_DEP   null_5;

	PTR_SETS  null_6;
	 };

struct  PROG_HEDR_STMT_S { /* for SgProgHedrStmt */
	PTR_BFND next_prog;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  prog_symb; /*program name*/

	PTR_LLND null_1;
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB control;    /*point to body of the program*/
	PTR_BLOB format_group;

	PTR_DEP  null_5;
	PTR_DEP  null_6;

	PTR_SETS null_7;
	 };

struct  SUBROUTINE_STMT_S {/* for SgProcHedrStmt */
	PTR_BFND next_proc;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  proc_symb; /*procedure name*/

	PTR_LLND null_2;
	PTR_LLND prefix; /*added by Yanmi*/
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB control; /*potint to body of the subrutine*/
	PTR_BLOB format_group;

	PTR_DEP  null_5;
	PTR_DEP  null_6;

	PTR_SETS null_7;
	 };

struct  BLOCK_DATA_STMT_S {/* for SgBlockDataStmt */
	PTR_BFND blockdata_end;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  blockdata_symb; /*block_dsta_name*/

	PTR_LLND null_1;
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB control;      /*specification_part*/
	PTR_BLOB null_5;

	PTR_DEP  null_6;
	PTR_DEP  null_7;

	PTR_SETS null_8;
	 };

struct  MODULE_STMT_S { /* for SgModuleStmt */
	PTR_BFND module_end;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  module_symb;   /*MODULE_NAME*/

	PTR_LLND null_1;
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB control; /*specification patr*/
	PTR_BLOB format_group;  /*module subprogram part*/

	PTR_DEP  null_5;
	PTR_DEP  null_6;

	PTR_SETS null_7;
	 };

struct  INTERFACE_STMT_S {/* for SgInterfaceStmt */
	PTR_BFND interface_end;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  interface_symb; /*point to gene_spec*/

	PTR_LLND null_1;
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB control; /*interface body*/
	PTR_BLOB null_5;

	PTR_DEP  null_7;
	PTR_DEP  null_8;

	PTR_SETS null_9;
	 };

struct  ENTRY_STMT_S {/* for SgStatement */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  entry_name;/*ENTRY_NAME*/

	PTR_LLND result; /*result name*/
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB null_5;
	PTR_BLOB null_6;

	PTR_DEP  null_7;
	PTR_DEP  null_8;
	PTR_SETS null_9;
	 };

struct  STMT_FUNCTION_STMT_S  {   /* for SgStmtFunctionStmt */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  func_symb; /*function name*/

	PTR_LLND return_value;  /* for scalar_expr after the "=" */
	PTR_LLND null_1;
	PTR_LLND null_2;

	PTR_LABEL null_3;

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  null_6;
	PTR_DEP  null_7;

	PTR_SETS null_8;
	 };

struct RETURN_STMT_S {/* for SgReturnStmt */
	PTR_BFND next_bif;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND expr;  /*return  expression*/
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB null_5;
	PTR_BLOB null_6;

	PTR_DEP null_7;
	PTR_DEP null_8;
	PTR_SETS null_9;

	};

struct  USE_STMT_S {  /* for SgUseStmt */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  module_symb; /*PTR_SYMB.variant==MODULE_NAME*/

	PTR_LLND useonly_expr;  /* PTR_LLND.variant==ONLY_NODE,
				   ONLY name list */
	PTR_LLND userename_expr; /*PTR_LLND.variant==RENAME_NODE,
				   RENAME name list */
	PTR_LLND null_2;

	PTR_LABEL null_3;

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  null_6;
	PTR_DEP  null_7;

	PTR_SETS null_8;
	 };

struct CALL_STMT_S {/* for SgCallStmt */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND call_exp;  /*procedure call expression*/
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB null_5;
	PTR_BLOB null_6;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

struct  READ_STMT_S {/* for variant==READ_STAT SgInputOutputStmt */        
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND format;    /*only used by no control
				  specification list*/
	PTR_LLND expr_list; /*read item list*/
	PTR_LLND control_list; /*only used by control spectification*/

	PTR_LABEL fomt_label;/* format label*/

	PTR_BLOB null_3;
	PTR_BLOB null_4;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

/*WriteStmt*/
/*
struct  WRITE_STMT_S {  variant==WRITE_STAT
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND null_2;
	PTR_LLND expr_list; output item list
	PTR_LLND control_list;  control specification

	PTR_LABEL null_3;

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 }               
*/

/*PrintStmt*/
struct  PRINT_STMT_S {      /*variant==PRINT_STAT SgInputOutputStmt */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND format; /*only used by no control specification list*/
	PTR_LLND expr_list; /*output item list*/
	PTR_LLND null_2;

	PTR_LABEL fomt_label;/* format label*/

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

/*OpenStmt*/
struct  OPEN_STMT_S { /*variant=OPEN_STAT SgIOControlStmt */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND control;/*open specifiation list*/
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB null_5;
	PTR_BLOB null_6;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

/*CloseStmt*/
struct  CLOSE_STMT_S { /*variant=CLOSE_STAT SgIOControlStmt */
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND control; /*close specification list*/
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB null_5;
	PTR_BLOB null_6;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

/*FormatStmt*/
struct  FORMAT_STMT_S {/* SgIOControlStmt variant==FORMAT_STAT*/
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND format; /*format specification item list */
	PTR_LLND null_2;
	PTR_LLND null_3;

	PTR_LABEL null_4;

	PTR_BLOB null_5;
	PTR_BLOB null_6;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };
/*InquireStmt*/
struct  INQUIRE_STMT_S {    /* SgIOControlStmt variant==INQUIRE_STAT*/
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND spec_list; /*specification list*/
	PTR_LLND length; /*IOLENGTH  value*/
	PTR_LLND output_item; /*output item list*/

	PTR_LABEL null_2;

	PTR_BLOB null_3;
	PTR_BLOB null_4;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
 };

/*BackspaceStmt*/
struct  BACKSPACE_STMT_S {  /* SgIOControlStmt  variant==BACKSPACE_STAT*/
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND file_expr; /*external file unit*/
	PTR_LLND posit_list; /*position specification list */
	PTR_LLND null_2;

	PTR_LABEL null_3;

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

/*RewindStmt*/
struct  REWIND_STMT_S { /* SgIOControlStmt variant==REWIND_STAT*/
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND file_expr; /*external file unit*/
	PTR_LLND posit_list; /*position specification list */
	PTR_LLND null_2;

	PTR_LABEL null_3;

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };

/*EndfileStmt*/
struct  END_FILE_STMT_S {   /* SgIOControlStmt variant==ENDFILE_STAT*/
	PTR_BFND next_stat;
	PTR_CMNT cmnt_ptr;

	PTR_SYMB  null_1;

	PTR_LLND file_expr; /*external file unit*/
	PTR_LLND posit_list; /*position specification list */
	PTR_LLND null_2;

	PTR_LABEL null_3;

	PTR_BLOB null_4;
	PTR_BLOB null_5;

	PTR_DEP  dep_from;
	PTR_DEP  dep_to;

	PTR_SETS sets;
	 };


 struct  REDISTRIBUTE_STMT_S  { 
		PTR_BFND next_stat; /*??*/
		PTR_CMNT cmnt_ptr;  /*comment*/

		PTR_SYMB   null_0;

		PTR_LLND  distributees; /*pointer to distributee or distributees*/
		PTR_LLND  attr_node;    /*point to SgAttributeExp node*/
		PTR_LLND  null_1;

		PTR_LABEL  null_2;

		PTR_BLOB   null_3;
		PTR_BLOB   null_4;

		PTR_DEP    dep_from;
		PTR_DEP    def_to;

		PTR_SETS    sets; 
	 };

struct  REALIGN_STMT_S  {
		PTR_BFND next_stat; /*??*/
		PTR_CMNT cmnt_ptr;  /*comment*/
		
		PTR_SYMB   null_0;

		PTR_LLND  alignees; /*pointer to alignee or alignees*/
		PTR_LLND  attr_node;    /*point to SgAttributeExp node*/
		PTR_LLND  null_1;

		PTR_LABEL  null_2;

		PTR_BLOB   null_3;
		PTR_BLOB   null_4;

		PTR_DEP    dep_from;
		PTR_DEP    def_to;

		PTR_SETS    sets; 
	 } ;

struct  FORALL_STMT_S  {
		PTR_BFND for_end;   /*pointer to next statement of END FORALL or 
							 the next stmt after forall_asignment*/
		PTR_CMNT cmnt_ptr;  /*comment*/

		PTR_SYMB null_1;    

		PTR_LLND  head_exp_list; /*point to forall header*/
		PTR_LLND  scalar_mask_expr;/*point to scalar_mask expression*/
		PTR_LLND  null_2;

		PTR_LABEL  null_3;

		PTR_BLOB   control;
		PTR_BLOB   null_4;

		PTR_DEP    dep_from;
		PTR_DEP    def_to;

		PTR_SETS    sets; 
	 } ;


 struct  INDEPDENT_STMT_S {
		PTR_BFND do_stmt;   /*point to related FORALL or DO statement*/
		PTR_CMNT cmnt_ptr;  /*comment*/

		PTR_SYMB   null_1;    

		PTR_LLND  new_varible_list; /*point to new varible list*/
		PTR_LLND  null_2;
		PTR_LLND  null_3;

		PTR_LABEL  null_4;

		PTR_BLOB   control;
		PTR_BLOB   null_5;

		PTR_DEP    dep_from;
		PTR_DEP    def_to;

		PTR_SETS    sets; 
	  }  ;

/* designed for HPF*/

 struct  INCLUDE_S {
          PTR_BFND  next_prog;
          PTR_CMNT  cmnt_ptr;

          PTR_SYMB  symb;

          PTR_LLND  null_1;
          PTR_LLND  null_2;
          PTR_LLND  null_3;

          PTR_LABEL null_4;

          PTR_BLOB  null_5;
          PTR_BLOB  null_6;

          PTR_DEP   null_7;
          PTR_DEP   null_8;

          PTR_SETS  null_9;		
	  } ;

/* designed by Lxy for INCLUDE_STMT 11.18.1995 */

struct bfnd {
	
	 int    variant, id;        /* variant and identification tags */
	 int    index;              /* used in the strongly con. comp. routines */
	 int    g_line, l_line;     /* global & local line numbers */
	 int        decl_specs;     /* declaration specifiers stored with
								bif nodes: static, extern, friend, and inline */
	 int    checked;             /* add by zheng.gb */

	 PTR_LABEL  label;
	 PTR_BFND   thread;

	 PTR_FNAME  filename;       /* point to the source filename */

	 PTR_BFND   control_parent;     /* current bif node in on the control blob list
							of control_parent */
	 PTR_PLNK   prop_list;      /* property list */
	
	 union bfnd_union_u {
	 
	 struct {
		  PTR_BFND  bf_ptr1;        /* used by the parser and should */
		  PTR_CMNT  cmnt_ptr;       /* to attach comments */

		  PTR_SYMB   symbol;     /* a symbol table entry */

		  PTR_LLND  ll_ptr1;        /* an L-value expr tree */
		  PTR_LLND  ll_ptr2;        /* an R-value expr tree */
		  PTR_LLND  ll_ptr3;        /* a spare expr tree (see below) */

		  PTR_LABEL lbl_ptr;        /* used by do */

		  PTR_BLOB  bl_ptr1;        /* a list of control dep subnodes */
		  PTR_BLOB  bl_ptr2;        /* another such list (for if stmt) */

		  PTR_DEP   dep_ptr1;       /* a list of dependences nodes */
		  PTR_DEP   dep_ptr2;       /* another list of dep nodes */

		  PTR_SETS  sets;       /* a list of sets like GEN, KILL etc */
		}               Template;


	 struct {
		  PTR_BFND  proc_list;	/* a list of procedures in this file */
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  list;	/* list of global const and type */

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  null_4;
		  
		  PTR_LABEL null_5;

		  PTR_BLOB  control;	/* used for list of procedures */
		  PTR_BLOB  null_6;

		  PTR_DEP   null_7;
		  PTR_DEP   null_8;
		  
		  PTR_SETS  null_9;
		}				Global;

	 struct {
		  PTR_BFND  next_prog;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  prog_symb;

		  PTR_LLND  null_1;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control;
		  PTR_BLOB  format_group;

		  PTR_DEP   null_5;
		  PTR_DEP   null_6;

		  PTR_SETS  null_7;
		}				program;

	 struct {
		  PTR_BFND  next_proc;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  proc_symb;

		  PTR_LLND  null_1;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control;
		  PTR_BLOB  format_group;

		  PTR_DEP   null_5;
		  PTR_DEP   null_6;
		  
		  PTR_SETS  null_7;
		}				procedure;

	 struct {
		  PTR_BFND  next_func;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  func_symb;

		  PTR_LLND  ftype;
		  PTR_LLND  null_1;
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  control;
		  PTR_BLOB  format_group;

		  PTR_DEP   null_4;
		  PTR_DEP   null_5;

		  PTR_SETS  null_6;
		}				function;

	 struct {
		  PTR_BFND  next_bif;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  null_1;

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  null_4;

		  PTR_LABEL null_5;

		  PTR_BLOB  control;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				basic_block;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  null_1;

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  null_4;

		  PTR_LABEL null_5;

		  PTR_BLOB  null_6;
		  PTR_BLOB  null_7;

		  PTR_DEP   null_8;
		  PTR_DEP   null_9;

		  PTR_SETS  sets;
		}				control_end;

	 struct {
		  PTR_BFND  true_branch;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  null_1;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  control_false;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				if_node;

	 struct {
		  PTR_BFND  true_branch;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  null_1;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  control_false;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				where_node;

	 struct {
		  PTR_BFND  loop_end;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB  null_1;

		  PTR_LLND  null_2;
		  PTR_LLND  null_3;
		  PTR_LLND  null_4;

		  PTR_LABEL null_5;

		  PTR_BLOB  control;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				loop_node;

	 struct {
		  PTR_BFND  for_end;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  control_var;

		  PTR_LLND  range;
		  PTR_LLND  increment;
		  PTR_LLND  where_cond;

		  PTR_LABEL doend;

		  PTR_BLOB  control;
		  PTR_BLOB  null_1;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				for_node;

	 struct {
		  PTR_BFND  forall_end;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  control_var;

		  PTR_LLND  range;
		  PTR_LLND  increment;
		  PTR_LLND  where_cond;

		  PTR_LABEL null_1;

		  PTR_BLOB  control;
		  PTR_BLOB  null_2;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				forall_nd;

	 struct {
		  PTR_BFND  alldo_end;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  control_var;

		  PTR_LLND  range;
		  PTR_LLND  increment;
		  PTR_LLND  null_0;

		  PTR_LABEL null_1;

		  PTR_BLOB  control;
		  PTR_BLOB  null_2;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				alldo_nd;

	 struct {
		  PTR_BFND  while_end;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB  null_1;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				while_node;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB  null_1;

		  PTR_LLND  condition;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  control_true;
		  PTR_BLOB  control_false;

		  PTR_DEP   null_5;
		  PTR_DEP   null_6;

		  PTR_SETS  sets;
		}				exit_node;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB  null_1;

		  PTR_LLND  l_value;
		  PTR_LLND  r_value;
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  null_4;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				assign;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  null_1;

		  PTR_LLND  l_value;
		  PTR_LLND  r_value;
		  PTR_LLND  null_2;

		  PTR_LABEL null_3;

		  PTR_BLOB  null_4;
		  PTR_BLOB  null_5;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				identify;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;

		  PTR_SYMB  null_1;

		  PTR_LLND  spec_string;
		  PTR_LLND  null_2;
		  PTR_LLND  null_3;

		  PTR_LABEL null_4;

		  PTR_BLOB  null_5;
		  PTR_BLOB  null_6;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				format;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB  null_1;

		  PTR_LLND  format;		   /* used by blaze only  */
		  PTR_LLND  expr_list;
		  PTR_LLND  control_list;  /* used by cedar fortan only */

		  PTR_LABEL null_2;

		  PTR_BLOB  null_3;
		  PTR_BLOB  null_4;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
		}				write_stat;

	 struct {
		  PTR_BFND  next_stat;
		  PTR_CMNT  cmnt_ptr;
		  
		  PTR_SYMB  null_1;

		  PTR_LLND  format;		/* used by blaze only */
		  PTR_LLND  var_list;
		  PTR_LLND  control_list;	/* used by cedar fortran */

		  PTR_LABEL null_2;

		  PTR_BLOB  null_3;
		  PTR_BLOB  null_4;

		  PTR_DEP   dep_from;
		  PTR_DEP   dep_to;

		  PTR_SETS  sets;
	     }					read_stat;
	  struct INCLUDE_S	        include;	        /* Not in sage++  */
	  struct STRUCT_DECL_S      struct_decl;        /* SgStructDeclStmt */
	  struct MISCELL_STMT_S     miscell;            /* SgMiscellStmt */
	  struct VAR_DECL_STMT_S    var_decl;           /* SgVarDeclStmt */
	  struct INTENT_STMT_S      intent;             /* SgIntentStmt*/
	  struct VAR_LIST_DECL_STMT_S  var_list_decl;   /* SgVarListDeclStmt */
	  struct IMPL_DECL_STMT_S      implicit_decl;   /* SgImplicitStmt */
	  struct NEST_VAR_LIST_DECL_S  nest_decl;       /* SgNestVarListDeclStmt */
	  struct HEAP_STMT_S           heap;            /* SgHeapStmt */
	  struct NULLIFY_STMT_S        nullify;         /* SgNullifyStmt */
	  struct DO_STMT_S          do_stmt;            /* SgForStmt */
	  struct DO_WHILE_STMT_S    do_while;           /* SgWhileStmt */
	  struct IF_STMT_S          if_stmt;            /* SgLogIfStmt */
	  struct IF_THEN_ELSE_S     if_then_else;       /* SgIfStmt */
	  struct IF_ELSE_IF_STMT_S  if_else_if;         /* SgIfElseIfStmt */
	  struct ARITH_IF_STMT_S    arith_if;       /* SgArithIfStmt */
	  struct WHERE_STMT_S       where_stmt;         /* SgWhereStmt */
	  struct WHERE_BLOCK_STMT_S where_block;        /* SgWhereBlockStmt */
	  struct CASE_STMT_S        case_stmt;          /* SgSwitchStmt */
	  struct CASE_OPTION_STMT_S  case_option;       /* SgCaseOptionStmt */
	  struct CONTINUE_STMT_S     cntinue;           /* SgContinueStmt */
	  struct GOTO_STMT_S        goto_stmt;          /* SgGotoStmt */
	  struct ASSIGN_STMT_S      assign_s;             /* SgAssignStmt */
	  struct ASSLAB_STAT_S      assign_label;       /* SgAssignLabelStmt */
	  struct ASSGOTO_NODE_S     assign_goto;        /* SgAssignGotoStmt */
	  struct COMPGOTO_NODE_S    computed_goto;  /* SgComputedGotoStmt */
	  struct STOP_STAT_S        stop;               /* SgStopOrPauseStmt */
	  struct CYCLE_STMT_S       cycle;              /* SgCycleStmt */
	  struct EXIT_STMT_S        exit_stmt;          /* SgExitStmt */
	  struct CONTROL_END_STMT_S  contol_end;        /* SgControlEndStmt */
	  struct FUNCTION_STMT_S    func_stmt;      /* SgFuncHedrStmt */
	  struct PROG_HEDR_STMT_S   prog_stmt;      /* SgProgHedrStmt */
	  struct SUBROUTINE_STMT_S  subroutine_stmt;    /* SgProcHedrStmt */
	  struct BLOCK_DATA_STMT_S  block_data;         /* SgBlockDataStmt */
	  struct MODULE_STMT_S      module_stmt;        /* SgModuleStmt */
	  struct INTERFACE_STMT_S   interface;          /* SgInterfaceStmt */
	  struct ENTRY_STMT_S       entry;              /* SgEntryStmt */
	  struct STMT_FUNCTION_STMT_S  stmt_func;       /* SgStmtFunctionStmt */
	  struct RETURN_STMT_S         return_stmt;     /* SgReturnStmt */
	  struct USE_STMT_S         use_stmt;           /* SgUseStmt */
	  struct CALL_STMT_S        call;               /* SgCallStmt */
	  struct PRINT_STMT_S       print_stat;         /* SgInputOutPutStmt */
	  struct OPEN_STMT_S        open_stat;          /* SgIoControlStmt */
	  struct CLOSE_STMT_S       close_stat;         /* SgIoControlStmt */
	  struct FORMAT_STMT_S      format_stat;        /* SgIoControlStmt */
	  struct INQUIRE_STMT_S     inquire_stat;       /* SgIoControlStmt */
	  struct BACKSPACE_STMT_S   backspace_stat;     /* SgIoControlStmt */
	  struct REWIND_STMT_S      rewind_stat;        /* SgIoControlStmt */
	  struct END_FILE_STMT_S    end_file_stat;      /* SgIoControlStmt */
      struct REDISTRIBUTE_STMT_S  	redistribute_stat;  /*SgRedistributeStmt*/
      struct REALIGN_STMT_S    	realign_stat;   	/*SgRealignStmt*/
      struct FORALL_STMT_S      	forall_Stat;  		/*SgForallStmt*/
      struct INDEPDENT_STMT_S   	indepdent_stat;  	/*SgIndepdentStmt*/
      /*Below is newly added by Zheng Qiang*/
          struct ASSOCIATED_STMT_S              associated_stat;
          /* Above is newly added by Zheng Qiang */

     }  entry;
};


#define __BIF_DEF__

